PageInfo = {
	getResolutionWidth  : function() { return self.screen.width; },
	getResolutionHeight : function() { return self.screen.height; },
	getColorDepth       : function() { return self.screen.colorDepth; },

	getScrollLeft       : function() { var scrollLeft = 0; if (document.documentElement && document.documentElement.scrollLeft && document.documentElement.scrollLeft != 0) { scrollLeft = document.documentElement.scrollLeft; } if (document.body && document.body.scrollLeft && document.body.scrollLeft != 0) { scrollLeft = document.body.scrollLeft; } if (window.pageXOffset && window.pageXOffset != 0) { scrollLeft = window.pageXOffset; } return scrollLeft; },
	getScrollTop        : function() { var scrollTop = 0; if (document.documentElement && document.documentElement.scrollTop && document.documentElement.scrollTop != 0) { scrollTop = document.documentElement.scrollTop; } if (document.body && document.body.scrollTop && document.body.scrollTop != 0) { scrollTop = document.body.scrollTop; } if (window.pageYOffset && window.pageYOffset != 0) { scrollTop = window.pageYOffset; } return scrollTop; },

	getDocumentWidth    : function() { var documentWidth = 0; var w1 = document.body.scrollWidth; var w2 = document.body.offsetWidth; if (w1 > w2) { documentWidth = document.body.scrollWidth; } else { documentWidth = document.body.offsetWidth; } return documentWidth; },
	getDocumentHeight   : function() { var documentHeight = 0; var h1 = document.body.scrollHeight; var h2 = document.body.offsetHeight; if (h1 > h2) { documentHeight = document.body.scrollHeight; } else { documentHeight = document.body.offsetHeight; } return documentHeight; },
	getVisibleWidth     : function() { var visibleWidth = 0; if (self.innerWidth) { visibleWidth = self.innerWidth; } else if (document.documentElement && document.documentElement.clientWidth) { visibleWidth = document.documentElement.clientWidth; } else if (document.body) { visibleWidth = document.body.clientWidth; } return visibleWidth; },
	getVisibleHeight    : function() { var visibleHeight = 0; if (self.innerHeight) { visibleHeight = self.innerHeight; } else if (document.documentElement && document.documentElement.clientHeight) { visibleHeight = document.documentElement.clientHeight; } else if (document.body) { visibleHeight = document.body.clientHeight; } return visibleHeight; },

	getElementLeft      : function(element) { var element = (typeof element == "string") ? document.getElementById(element) : element; var left = element.offsetLeft; var oParent = element.offsetParent; while (oParent != null) { left += oParent.offsetLeft; oParent = oParent.offsetParent; } return left; },
	getElementTop       : function(element) { var element = (typeof element == "string") ? document.getElementById(element) : element; var top = element.offsetTop; var oParent = element.offsetParent; while (oParent != null) { top += oParent.offsetTop; oParent = oParent.offsetParent; } return top; },
	getElementWidth     : function(element) { var element = (typeof element == "string") ? document.getElementById(element) : element; return element.offsetWidth; },
	getElementHeight    : function(element) { var element = (typeof element == "string") ? document.getElementById(element) : element; return element.offsetHeight; },

	getMouseX           : function() { return PageInfo.mouseX; },
	getMouseY           : function() { return PageInfo.mouseY; },

	mouseX: 0,
	mouseY: 0,
	onMouseMove: function(e) { e = (!e) ? window.event : e; PageInfo.mouseX = e.clientX + PageInfo.getScrollLeft(); PageInfo.mouseY = e.clientY + PageInfo.getScrollTop(); }
};
if (document.addEventListener) {
	document.addEventListener("mousemove", PageInfo.onMouseMove, false);
} else if (document.attachEvent) {
	document.attachEvent("onmousemove", PageInfo.onMouseMove);
}
ImgEdit = {
	img: "",
	w: 0,
	h: 0,
	startX: 0,
	startY: 0,
	mouseIsDown: false,
	loadingTextInterval: 0,
    editorImage: null,
	loaderImage: document.createElement("img"),
    cropRegion: document.createElement("div"),
	validDimension: /^\d{1,4}$/
};
ImgEdit.processImage = function(args){
	if (ImgEdit.cropRegion){
		ImgEdit.cropRegion.style.display = "none";
		ImgEdit.hideCropSize();
	}
	ImgEdit.showLoading();
	var request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject("Microsoft.XMLHTTP");
	request.open("POST", "index.php", true);
	request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	request.onreadystatechange = function(){
		if (request.readyState == 4){
			var json = eval("(" + request.responseText + ")");
			if (json.imageFound) {
				ImgEdit.img = json.img;
			    ImgEdit.w = json.w;
			    ImgEdit.h = json.h;
			    ImgEdit.loadImage();
			} 
            else {
                if(json.img == '0') ImgEdit.editorImage.innerHTML = '<span style="font-size:14px;font-weight:bold;color:green;white-space:nowrap">Image has been saved!</span>';
                else ImgEdit.editorImage.innerHTML = '<span style="font-size:14px;font-weight:bold;color:red;white-space:nowrap">Image was not found!</span>';
			}
		}
	};
	request.send("do=ImgProc&pic=" + ImgEdit.img + ((args) ? "&" + args : ""));
};
ImgEdit.loadImage = function(){
	ImgEdit.loaderImage.setAttribute("src", "index.php?do=ImgLoad&pic=" + ImgEdit.img + "&t=" + (new Date).getTime());
};
ImgEdit.displayImage = function(){
	clearInterval(ImgEdit.loadingTextInterval);
	
    var editorImage = ImgEdit.editorImage;
	editorImage.innerHTML = "";
	editorImage.style.width = ImgEdit.w + "px";
	editorImage.style.height = ImgEdit.h + "px";
	editorImage.style.backgroundImage = "url(" + ImgEdit.loaderImage.getAttribute('src') + ")";

	document.getElementById("txt-width").value = ImgEdit.w;
	document.getElementById("txt-height").value = ImgEdit.h;
};
ImgEdit.showLoading = function(){
    ImgEdit.editorImage.style.backgroundImage = "none";
    ImgEdit.editorImage.innerHTML =
		'<div id="loading-text">Loading Image<span id="ellipsis">...</span></div>';
	ImgEdit.loadingTextInterval = setInterval(function(){
		if (document.getElementById("ellipsis")){
			var dots = document.getElementById("ellipsis").innerHTML;
			document.getElementById("ellipsis").innerHTML = (dots != "...") ? dots += "." : "";
		}
	}, 500);
};
ImgEdit.txtWidthKeyup = function(){
	if (!document.getElementById("chk-constrain").checked) { return; }
	var w = document.getElementById("txt-width").value;
	if (ImgEdit.validDimension.test(w)){
		document.getElementById("txt-width").value = parseInt(w);
		document.getElementById("txt-height").value = parseInt((w * ImgEdit.h)/ImgEdit.w);
	}else if (w == ""){
		document.getElementById("txt-height").value = "";	
	}else{
		document.getElementById("txt-width").value = w.replace(/[^0-9]/g, "");
	}
};
ImgEdit.txtHeightKeyup = function(){
	if (!document.getElementById("chk-constrain").checked) { return; }
	var h = document.getElementById("txt-height").value;
	if (ImgEdit.validDimension.test(h)){
		document.getElementById("txt-height").value = parseInt(h);
		document.getElementById("txt-width").value = parseInt((h * ImgEdit.w)/ImgEdit.h);	
	}else if (h == ""){
		document.getElementById("txt-width").value = "";
	}else{
		document.getElementById("txt-height").value = h.replace(/[^0-9]/g, "");	
	}
};
ImgEdit.txtBlur = function(){
	var w = document.getElementById("txt-width").value;
	var h = document.getElementById("txt-height").value;
	if (!ImgEdit.validDimension.test(w) || !ImgEdit.validDimension.test(h)){
		document.getElementById("txt-width").value = ImgEdit.w;
		document.getElementById("txt-height").value = ImgEdit.h;	
	}
}
ImgEdit.resize = function(){
	var w = document.getElementById("txt-width").value;
	var h = document.getElementById("txt-height").value;
	
	if (!ImgEdit.validDimension.test(w) || !ImgEdit.validDimension.test(h)){
		alert("The image dimensions are not valid.");
		document.getElementById("txt-width").value = ImgEdit.w;
		document.getElementById("txt-height").value = ImgEdit.h;
		return;
	}
	if (w > 2000 || h > 2000){
		alert("Width and/or height cannot exceed 2000 pixels.");
		document.getElementById("txt-width").value = ImgEdit.w;
		document.getElementById("txt-height").value = ImgEdit.h;
		return;
	}
	ImgEdit.processImage("action=resize&w=" + w + "&h=" + h);
};
ImgEdit.rotate = function(degrees){
	ImgEdit.processImage("action=rotate&degrees=" + degrees);
};
ImgEdit.viewOriginal = function(){
	ImgEdit.processImage("action=viewOriginal");
};
ImgEdit.save = function(){
	ImgEdit.processImage("action=save");
};
ImgEdit.brighten = function(){
    ImgEdit.processImage("action=brighten&amt=20");
};
ImgEdit.darken = function(){
    ImgEdit.processImage("action=brighten&amt=-20");
};
ImgEdit.crop = function(){
	if (typeof ImgEdit == "undefined") { return; }
	if (ImgEdit.cropRegion.style.display == "none"){
		alert("You must select an area to crop before using this feature.");
		return;
	}
	var x = parseInt(ImgEdit.cropRegion.style.left) - PageInfo.getElementLeft(ImgEdit.editorImage);
	var y = parseInt(ImgEdit.cropRegion.style.top) - PageInfo.getElementTop(ImgEdit.editorImage);
	var w = parseInt(ImgEdit.cropRegion.style.width);
	var h = parseInt(ImgEdit.cropRegion.style.height);

	ImgEdit.processImage("action=crop&x=" + x + "&y=" + y + "&w=" + w + "&h=" + h);
};
ImgEdit.startCrop = function(){
	if (typeof ImgEdit == "undefined") { return; }
    
    var cropRegionStyle = ImgEdit.cropRegion.style;
    cropRegionStyle.left = PageInfo.getMouseX() + "px";
    cropRegionStyle.top = PageInfo.getMouseY() + "px";
    cropRegionStyle.width = "1px";
    cropRegionStyle.height = "1px";
    cropRegionStyle.display = "block";
	
    ImgEdit.startX = PageInfo.getMouseX();
	ImgEdit.startY = PageInfo.getMouseY();
};
ImgEdit.dragCrop = function(){
	if (typeof ImgEdit == "undefined") { return; }
	if (!ImgEdit.mouseIsDown) { return; }

	// mouse is to the right of starting point
	if (PageInfo.getMouseX() - ImgEdit.startX > 0) {
		ImgEdit.cropRegion.style.width = PageInfo.getMouseX() - ImgEdit.startX + "px";
	} else{ // mouse is to the left of starting point
		ImgEdit.cropRegion.style.left = PageInfo.getMouseX() + "px";
		ImgEdit.cropRegion.style.width = ImgEdit.startX - PageInfo.getMouseX() + "px";
	}
	// mouse is below the starting point
	if (PageInfo.getMouseY() - ImgEdit.startY > 0) {
		ImgEdit.cropRegion.style.height = PageInfo.getMouseY() - ImgEdit.startY + "px";
	} else { // mouse is above the starting point
		ImgEdit.cropRegion.style.top = PageInfo.getMouseY() + "px";
		ImgEdit.cropRegion.style.height = ImgEdit.startY - PageInfo.getMouseY() + "px";
	}
	ImgEdit.showCropSize(parseInt(ImgEdit.cropRegion.style.width), parseInt(ImgEdit.cropRegion.style.height));
};
ImgEdit.slideCrop = function(e){
	if (ImgEdit.cropRegion.style.display == "none") { return; }
	e = e || event;
	var code = (e.keyCode) ? e.keyCode : (e.which) ? e.which : null;
	if (!code) { return };
	switch (code){
		case 37: //left
			if(PageInfo.getElementLeft(ImgEdit.cropRegion) > PageInfo.getElementLeft(ImgEdit.editorImage)){
				ImgEdit.cropRegion.style.left = PageInfo.getElementLeft(ImgEdit.cropRegion) - 1 + "px";
			}
			break;
		case 38: //up
			if(PageInfo.getElementTop(ImgEdit.cropRegion) > PageInfo.getElementTop(ImgEdit.editorImage)){
				ImgEdit.cropRegion.style.top = PageInfo.getElementTop(ImgEdit.cropRegion) - 1 + "px";
			}		
			break;
		case 39: //right
			if (PageInfo.getElementLeft(ImgEdit.cropRegion) + PageInfo.getElementWidth(ImgEdit.cropRegion) < PageInfo.getElementLeft(ImgEdit.editorImage) + PageInfo.getElementWidth(ImgEdit.editorImage)){
				ImgEdit.cropRegion.style.left = PageInfo.getElementLeft(ImgEdit.cropRegion) + 1 + "px";
			}
			break;
		case 40: //down
			if (PageInfo.getElementTop(ImgEdit.cropRegion) + PageInfo.getElementHeight(ImgEdit.cropRegion) < PageInfo.getElementTop(ImgEdit.editorImage) + PageInfo.getElementHeight(ImgEdit.editorImage)){
				ImgEdit.cropRegion.style.top = PageInfo.getElementTop(ImgEdit.cropRegion) + 1 + "px";
			}		
			break;
	}
};
ImgEdit.showCropSize = function(w, h){
	//document.getElementById("crop-size").innerHTML = w + " by " + h + " (use arrow keys to slide)";
};
ImgEdit.hideCropSize = function(){
	//document.getElementById("crop-size").innerHTML = "";
};
ImgEdit.addEvent = function(obj, evt, func){
	if (window.addEventListener){
		obj.addEventListener(evt, func, false);
	}else if (window.attachEvent){
		obj.attachEvent("on" + evt, func);
	}
};
ImgEdit.init = function(img){

    ImgEdit.img = img || "";
    ImgEdit.editorImage = document.getElementById("image");

	ImgEdit.loaderImage.onload = function(){ ImgEdit.displayImage(); };

	ImgEdit.processImage("action=viewOriginal");
	
    ImgEdit.cropRegion.className = "cropRegion";
	var bodyNode = document.getElementsByTagName("body").item(0);
	bodyNode.appendChild(ImgEdit.cropRegion);
	
	ImgEdit.addEvent(document, "mousedown", function(){ ImgEdit.mouseIsDown = true; });
	ImgEdit.addEvent(document, "mouseup", function(){ ImgEdit.mouseIsDown = false; });
	ImgEdit.addEvent(ImgEdit.editorImage, "mouseover", function(){ ImgEdit.editorImage.style.cursor = "crosshair"; });
	ImgEdit.addEvent(ImgEdit.editorImage, "mousedown", ImgEdit.startCrop);
	ImgEdit.addEvent(ImgEdit.editorImage, "mousemove", ImgEdit.dragCrop);
	ImgEdit.addEvent(ImgEdit.cropRegion, "mousedown", ImgEdit.startCrop);
	ImgEdit.addEvent(ImgEdit.cropRegion, "mousemove", ImgEdit.dragCrop);
	ImgEdit.addEvent(document, "dblclick", function() { ImgEdit.cropRegion.style.display = "none"; ImgEdit.hideCropSize(); });
	ImgEdit.addEvent(document, "keydown", ImgEdit.slideCrop);
	ImgEdit.addEvent(document.getElementById("txt-width"), "keyup", ImgEdit.txtWidthKeyup);
	ImgEdit.addEvent(document.getElementById("txt-width"), "blur", ImgEdit.txtBlur);
	ImgEdit.addEvent(document.getElementById("txt-height"), "keyup", ImgEdit.txtHeightKeyup);
	ImgEdit.addEvent(document.getElementById("txt-height"), "blur", ImgEdit.txtBlur);
};